local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local action = x.Action
local artifact = x.Artifact
local buff = x.Buff
local cooldown = x.Cooldown
local debuff = x.Debuff
local dot = x.Dot
local equipped = x.Equipped
local prev_gcd = x.PrevGCD
local talent = x.Talent
local target = x.Target

		a.UpdateUAs()
		s.UpdateDoT(146739, "Corruption")
		s.UpdateDoT(980, "Agony")
		s.UpdateDoT(63106, "Siphon Life")
		s.UpdateCooldown(196098, "Soul Harvest")
		s.UpdateCastTime(30108, "Unstable Affliction")
		s.UpdateBuff(235156, "Empowered Life Tap")
		s.UpdateBuff(196098, "Soul Harvest")
		s.UpdateBuff(216708, "Deadwind Harvester")
		s.UpdateBuff(216695, "Tormented Souls")
		s.UpdateInFlight(27243, "Seed of Corruption")
		dot.corruption.tick_time = 2 / x.Haste
		dot.agony.tick_time = 2 / x.Haste
		dot.siphon_life.tick_time = 3 / x.Haste

		if talent.malefic_grasp.enabled then
			-- Malefic Grasp

			a.Flash("summon_pet,if=!talent.grimoire_of_supremacy.enabled&(!talent.grimoire_of_sacrifice.enabled|buff.demonic_power.down)"
					,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&active_enemies>1"
					,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&active_enemies=1")

			a.Flash("reap_souls,if=!buff.deadwind_harvester.remains&time>5&((buff.tormented_souls.react>=4+active_enemies|buff.tormented_souls.react>=9)|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
					,"agony,cycle_targets=1,max_cycle_targets=5,target_if=sim.target!=target&talent.soul_harvest.enabled&cooldown.soul_harvest.remains<cast_time*6&remains<=duration*0.3&target.time_to_die>=remains&time_to_die>tick_time*3"
					,"agony,cycle_targets=1,max_cycle_targets=4,if=remains<=(tick_time+gcd)"
					,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3&soul_shard=5"
					,"unstable_affliction,if=target=sim.target&soul_shard=5"
					,"drain_soul,cycle_targets=1,if=target.time_to_die<gcd*2&soul_shard<5"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
					,"service_pet,if=dot.corruption.remains&dot.agony.remains"
					,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
					,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
--					,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
--					,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
					,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
--					,"blood_fury"
					,"siphon_life,cycle_targets=1,if=remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"
					,"corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"
					,"phantom_singularity"
					,"soul_harvest,if=buff.active_uas.stack>1&buff.soul_harvest.remains<=8&sim.target=target&(!talent.deaths_embrace.enabled|target.time_to_die>=136|target.time_to_die<=40)"
--					,"potion,if=target.time_to_die<=70"
--					,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&buff.active_uas.stack>=2"
					,"agony,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.agony)"
					,"siphon_life,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.siphon_life)"
					,"corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.corruption)"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3|talent.malefic_grasp.enabled&target.time_to_die>15&mana.pct<10"
					,"seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>=5&dot.corruption.remains<=cast_time+travel_time)"
					,"unstable_affliction,if=target=sim.target&target.time_to_die<30"
					,"unstable_affliction,if=target=sim.target&active_enemies>1&soul_shard>=4"
					,"unstable_affliction,if=target=sim.target&(buff.active_uas.stack=0|(!prev_gcd.3.unstable_affliction&prev_gcd.1.unstable_affliction))&dot.agony.remains>cast_time+(6.5*spell_haste)"
					,"reap_souls,if=buff.deadwind_harvester.remains<dot.unstable_affliction_1.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_2.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_3.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_4.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_5.remains&buff.active_uas.stack>1"
					,"life_tap,if=mana.pct<=10"
					,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
					,"drain_soul,chain=1,interrupt=1"
					,"life_tap,moving=1,if=mana.pct<80"
					,"agony,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
					,"siphon_life,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
					,"corruption,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"
					,"life_tap,moving=0")
		elseif talent.writhe_in_agony.enabled then
			-- Writhe
			s.UpdateBuff(242586, "Concordance of the Legionfall")
			a.Flash("reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.tormented_souls.react>=5|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
					,"reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.soul_harvest.remains>=(5+1.5*equipped.144364)&buff.active_uas.stack>1|buff.concordance_of_the_legionfall.react|trinket.proc.intellect.react|trinket.stacking_proc.intellect.react|trinket.proc.mastery.react|trinket.stacking_proc.mastery.react|trinket.proc.crit.react|trinket.stacking_proc.crit.react|trinket.proc.versatility.react|trinket.stacking_proc.versatility.react|trinket.proc.spell_power.react|trinket.stacking_proc.spell_power.react)"
					,"agony,if=remains<=tick_time+gcd"
					,"agony,cycle_targets=1,max_cycle_targets=5,target_if=sim.target!=target&talent.soul_harvest.enabled&cooldown.soul_harvest.remains<cast_time*6&remains<=duration*0.3&target.time_to_die>=remains&time_to_die>tick_time*3"
					,"agony,cycle_targets=1,max_cycle_targets=3,target_if=sim.target!=target&remains<=tick_time+gcd&time_to_die>tick_time*3"
					,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3&soul_shard=5"
					,"unstable_affliction,if=soul_shard=5|(time_to_die<=((duration+cast_time)*soul_shard))"
					,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
					,"service_pet,if=dot.corruption.remains&dot.agony.remains"
					,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
					,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
					,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
					,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
					,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
					,"blood_fury"
					,"soul_harvest,if=sim.target=target&buff.soul_harvest.remains<=8&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)&(buff.active_uas.stack>=2|active_enemies>3)&(!talent.deaths_embrace.enabled|time_to_die>120|time_to_die<30)"
					,"potion,if=target.time_to_die<=70"
					,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&(trinket.proc.any.react|trinket.stack_proc.any.react|buff.active_uas.stack>=2)"
					,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd&time_to_die>tick_time*2"
					,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&((spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled)|spell_targets.seed_of_corruption<5)&time_to_die>tick_time*2"
					,"life_tap,if=mana.pct<40&(buff.active_uas.stack<1|!buff.deadwind_harvester.remains)"
					,"reap_souls,if=(buff.deadwind_harvester.remains+buff.tormented_souls.react*(5+equipped.144364))>=(12*(5+1.5*equipped.144364))"
					,"phantom_singularity"
					,"seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>3&dot.corruption.refreshable)"
					,"unstable_affliction,if=talent.contagion.enabled&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
					,"unstable_affliction,if=talent.absolute_corruption.enabled&set_bonus.tier21_4pc&debuff.tormented_agony.remains<=cast_time"
					,"unstable_affliction,cycle_targets=1,target_if=buff.deadwind_harvester.remains>=duration+cast_time&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
					,"unstable_affliction,if=buff.deadwind_harvester.remains>tick_time*2&(!set_bonus.tier21_4pc|talent.contagion.enabled|soul_shard>1)&(!talent.contagion.enabled|soul_shard>1|buff.soul_harvest.remains)&(dot.unstable_affliction_1.ticking+dot.unstable_affliction_2.ticking+dot.unstable_affliction_3.ticking+dot.unstable_affliction_4.ticking+dot.unstable_affliction_5.ticking<5)"
					,"reap_souls,if=!buff.deadwind_harvester.remains&buff.active_uas.stack>1"
					,"reap_souls,if=!buff.deadwind_harvester.remains&prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3&(!buff.deadwind_harvester.remains|buff.active_uas.stack<1)"
					,"agony,if=refreshable&time_to_die>=remains"
					,"siphon_life,if=refreshable&time_to_die>=remains"
					,"corruption,if=refreshable&time_to_die>=remains"
					,"agony,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
					,"siphon_life,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
					,"corruption,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
					,"life_tap,if=mana.pct<=10"
					,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
					,"drain_soul,chain=1,interrupt=1"
					,"life_tap,moving=1,if=mana.pct<80"
					,"agony,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"life_tap,moving=0")
		elseif talent.haunt.enabled then
			-- Haunt
			s.UpdateCooldown(48181, "Haunt")
			s.UpdateDebuff(48181, "Haunt")
			a.Flash("reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.tormented_souls.react>=5|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"
					,"reap_souls,if=debuff.haunt.remains&!buff.deadwind_harvester.remains"
					,"reap_souls,if=active_enemies>1&!buff.deadwind_harvester.remains&time>5&soul_shard>0&((talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|spell_targets.seed_of_corruption>=5)"
					,"agony,cycle_targets=1,if=remains<=tick_time+gcd"
					,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
					,"service_pet,if=dot.corruption.remains&dot.agony.remains"
					,"summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"
					,"summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"
					,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
					,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
					,"berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"
					,"blood_fury"
					,"soul_harvest,if=buff.soul_harvest.remains<=8&buff.active_uas.stack>=1&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)"
					,"potion,if=!talent.soul_harvest.enabled&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|buff.active_uas.stack>2)"
					,"potion,if=talent.soul_harvest.enabled&buff.soul_harvest.remains&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|!cooldown.haunt.remains|buff.active_uas.stack>2)"
					,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd"
					,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&(spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<5)"
					,"reap_souls,if=(buff.deadwind_harvester.remains+buff.tormented_souls.react*(5+equipped.144364))>=(12*(5+1.5*equipped.144364))"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"
					,"phantom_singularity"
					,"haunt"
					,"agony,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains"
					,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3|talent.malefic_grasp.enabled&target.time_to_die>15&mana.pct<10"
					,"siphon_life,if=remains<=duration*0.3&target.time_to_die>=remains"
					,"siphon_life,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"
					,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3|spell_targets.seed_of_corruption>=5|spell_targets.seed_of_corruption>=3&dot.corruption.remains<=cast_time+travel_time"
					,"corruption,if=remains<=duration*0.3&target.time_to_die>=remains"
					,"corruption,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"
					,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&((soul_shard>=4&!talent.contagion.enabled)|soul_shard>=5|target.time_to_die<30)"
					,"unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&soul_shard>=4&talent.contagion.enabled&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
					,"unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&(equipped.132381|equipped.132457)&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
					,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&talent.contagion.enabled&soul_shard>=4&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
					,"unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*2"
					,"reap_souls,if=!buff.deadwind_harvester.remains&(buff.active_uas.stack>1|(prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1))"
					,"life_tap,if=mana.pct<=10"
					,"life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"
					,"drain_soul,chain=1,interrupt=1"
					,"life_tap,moving=1,if=mana.pct<80"
					,"agony,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
					,"life_tap,moving=0")
		end

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.EnemyDetected, x.EnemyDetected, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Spell table references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-s-castable

-- Spell table references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-s-castable

-- Example flash color coding:
-- White - Default
-- Yellow - Limited Time or No Global Cooldown
-- Purple - AOE or Positional Damage
-- Blue - AOE Debuff
-- Orange - Finishing Move
-- Aqua - Spell Interrupt, Reflect or Dispel
-- Green - Self Buff or Turn Autocast On
-- Red - Emergency Mitigation Cooldowns or Turn Autocast Off
-- Pink - Optional

a.spells["summon_pet,if=!talent.grimoire_of_supremacy.enabled&(!talent.grimoire_of_sacrifice.enabled|buff.demonic_power.down)"] = {
	ID = 712--[[Summon Succubus]],
	Check = function(z)
		return not UnitExists("pet") and x.ShouldPermanentBuff and not talent.grimoire_of_supremacy.enabled and (x.Spec == 2 or not talent.grimoire_of_sacrifice.enabled or buff.demonic_power.down)
	end,
	FlashColor = "Green",
	FlashID = {712--[[Summon Succubus]], 691--[[Summon Felhunter]], 697--[[Summon Voidwalker]], 688--[[Summon Imp]], 30146--[[Summon Felguard]]},
}

a.spells["summon_infernal,if=talent.grimoire_of_supremacy.enabled&active_enemies>1"] = {
	ID = 157898--[[Summon Infernal]],
	Check = function(z)
		return not UnitExists("pet") and x.ShouldPermanentBuff and talent.grimoire_of_supremacy.enabled and x.ActiveEnemies > 1
	end,
	FlashColor = "Green",
	NoRangeCheck = true,
}

a.spells["summon_doomguard,if=talent.grimoire_of_supremacy.enabled&active_enemies=1"] = {
	ID = 157757--[[Summon Doomguard]],
	Check = function(z)
		return not UnitExists("pet") and x.ShouldPermanentBuff and talent.grimoire_of_supremacy.enabled and x.ActiveEnemies <= 1
	end,
	FlashColor = "Green",
}

--[[
  __  __       _       __ _         ____                     
 |  \/  | __ _| | ___ / _(_) ___   / ___|_ __ __ _ ___ _ __  
 | |\/| |/ _` | |/ _ \ |_| |/ __| | |  _| '__/ _` / __| '_ \ 
 | |  | | (_| | |  __/  _| | (__  | |_| | | | (_| \__ \ |_) |
 |_|  |_|\__,_|_|\___|_| |_|\___|  \____|_|  \__,_|___/ .__/ 
                                                      |_|    ]]

a.spells["reap_souls,if=!buff.deadwind_harvester.remains&time>5&((buff.tormented_souls.react>=4+active_enemies|buff.tormented_souls.react>=9)|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return buff.tormented_souls.react_nogcd >= 1 and not buff.deadwind_harvester.up_nogcd and s.Time() > 5 and ((buff.tormented_souls.react_nogcd >= 4 + x.ActiveEnemies or buff.tormented_souls.react_nogcd >= 9) or target.time_to_die <= buff.tormented_souls.react_nogcd * (5 + 1.5 * s.If(equipped[144364], 1, 0)) + (buff.deadwind_harvester.remains_nogcd * (5 + 1.5 * s.If(equipped[144364], 1, 0)) / 12 * (5 + 1.5 * s.If(equipped[144364], 1, 0) )))
	end,
}

a.spells["agony,cycle_targets=1,max_cycle_targets=5,target_if=sim.target!=target&talent.soul_harvest.enabled&cooldown.soul_harvest.remains<cast_time*6&remains<=duration*0.3&target.time_to_die>=remains&time_to_die>tick_time*3"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return talent.soul_harvest.enabled and cooldown.soul_harvest.remains < x.MaxGCD * 6 and dot.agony.refreshable and target.time_to_die >= dot.agony.remains and target.time_to_die > dot.agony.tick_time * 3
	end,
}

a.spells["agony,cycle_targets=1,max_cycle_targets=4,if=remains<=(tick_time+gcd)"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.remains <= (dot.agony.tick_time + x.MaxGCD)
	end,
}

a.spells["seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3&soul_shard=5"] = {
	ID = 27243--[[Seed of Corruption]],
	Check = function(z)
		return talent.sow_the_seeds.enabled and x.ActiveEnemies >= 3 and x.SoulShards == 5
	end,
}

a.spells["unstable_affliction,if=target=sim.target&soul_shard=5"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.SoulShards == 5
	end,
}

a.spells["drain_soul,cycle_targets=1,if=target.time_to_die<gcd*2&soul_shard<5"] = {
	ID = 198590--[[Drain Soul]],
	Check = function(z)
		return target.time_to_die < x.MaxGCD * 2 and x.SoulShards < 5
	end,
}

a.spells["life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<=gcd"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return talent.empowered_life_tap.enabled and buff.empowered_life_tap.remains <= x.MaxGCD
	end,
}

a.spells["service_pet,if=dot.corruption.remains&dot.agony.remains"] = {
	ID = 111897--[[Grimoire: Felhunter]],
	Check = function(z)
		return x.SoulShards >= 1 and dot.corruption.up and dot.agony.up
	end,
	NoRangeCheck = true,
	FlashID = {111897--[[Grimoire: Felhunter]], 111859--[[Grimoire: Imp]], 111896--[[Grimoire: Succubus]], 111895--[[Grimoire: Voidwalker]]},
}

a.spells["summon_doomguard,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal<=2&(target.time_to_die>180|target.health.pct<=20|target.time_to_die<30)"] = {
	ID = 18540--[[Summon Doomguard]],
	Check = function(z)
		return x.SoulShards >= 1 and x.UseLongCD and not talent.grimoire_of_supremacy.enabled and x.ActiveEnemies <= 2 and (target.time_to_die > 180 or target.health.pct <= 20 or target.time_to_die < 30)
	end,
	NoRangeCheck = true,
	FlashColor = "Pink",
	Continue = true,
}

a.spells["summon_infernal,if=!talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>2"] = {
	ID = 1122--[[Summon Infernal]],
	Check = function(z)
		return x.SoulShards >= 1 and x.UseLongCD and not talent.grimoire_of_supremacy.enabled and x.ActiveEnemies > 2
	end,
	NoRangeCheck = true,
	FlashColor = "Pink",
	Continue = true,
}
,"summon_doomguard,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal=1&equipped.132379&!cooldown.sindorei_spite_icd.remains"
,"summon_infernal,if=talent.grimoire_of_supremacy.enabled&spell_targets.summon_infernal>1&equipped.132379&!cooldown.sindorei_spite_icd.remains"

a.spells["berserking,if=prev_gcd.1.unstable_affliction|buff.soul_harvest.remains>=10"] = {
	ID = 26297--[[Berserking]],
	NoGCD = true,
	Continue = true,
	CheckFirst = function(z)
		return x.UseLongCD and (prev_gcd[1].unstable_affliction or buff.soul_harvest.remains_nogcd >= 10)
	end,
	FlashColor = "Yellow",
}
,"blood_fury"

a.spells["siphon_life,cycle_targets=1,if=remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"] = {
	ID = 63106--[[Siphon Life]],
	Check = function(z)
		return dot.siphon_life.remains <= (dot.siphon_life.tick_time + x.MaxGCD) and target.time_to_die > dot.siphon_life.tick_time * 3
	end,
}

a.spells["corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(tick_time+gcd)&target.time_to_die>tick_time*3"] = {
	ID = 172--[[Corruption]],
	Check = function(z)
		return (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.ActiveEnemies < 5 and dot.corruption.remains <= (dot.corruption.tick_time + x.MaxGCD) and target.time_to_die > dot.corruption.tick_time * 3
	end,
}

a.spells["phantom_singularity"] = {
	ID = 205179--[[Phantom Singularity]],
	Check = function(z)
		return x.InCombat
	end,
}

a.spells["soul_harvest,if=buff.active_uas.stack>1&buff.soul_harvest.remains<=8&sim.target=target&(!talent.deaths_embrace.enabled|target.time_to_die>=136|target.time_to_die<=40)"] = {
	ID = 196098--[[Soul Harvest]],
	NoGCD = true,
	FlashColor = "Yellow",
	Continue = true,
	Check = function(z)
		return x.UseLongCD and buff.active_uas.stack > 1 and buff.soul_harvest.remains_nogcd <= 8 and (not talent.deaths_embrace.enabled or target.time_to_die >= 136 or target.time_to_die<=40)
	end,
}
,"potion,if=target.time_to_die<=70"
,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&buff.active_uas.stack>=2"

a.spells["agony,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.agony)"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.refreshable and target.time_to_die >= dot.agony.remains and (buff.active_uas.stack == 0 or prev_gcd[1].agony)
	end,
}

a.spells["siphon_life,cycle_targets=1,if=remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.siphon_life)"] = {
	ID = 63106--[[Siphon Life]],
	Check = function(z)
		return dot.siphon_life.refreshable and target.time_to_die > dot.siphon_life.remains and (buff.active_uas.stack == 0 or prev_gcd[1].siphon_life)
	end,
}

a.spells["corruption,cycle_targets=1,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&remains<=(duration*0.3)&target.time_to_die>=remains&(buff.active_uas.stack=0|prev_gcd.1.corruption)"] = {
	ID = 172--[[Corruption]],
	Check = function(z)
		return (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.ActiveEnemies < 5 and dot.corruption.refreshable and target.time_to_die >= dot.corruption.remains and (buff.active_uas.stack == 0 or prev_gcd[1].corruption)
	end,
}

a.spells["life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3|talent.malefic_grasp.enabled&target.time_to_die>15&mana.pct<10"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return talent.empowered_life_tap.enabled and buff.empowered_life_tap.refreshable or talent.malefic_grasp.enabled and target.time_to_die > 15 and x.ManaPercent < 10
	end,
}

a.spells["seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>=5&dot.corruption.remains<=cast_time+travel_time)"] = {
	ID = 27243--[[Seed of Corruption]],
	Check = function(z)
		return (talent.sow_the_seeds.enabled and x.ActiveEnemies >= 3) or (x.ActiveEnemies >= 5 and dot.corruption.remains <= action.seed_of_corruption.cast_time + action.seed_of_corruption.travel_time)
	end,
}

a.spells["unstable_affliction,if=target=sim.target&target.time_to_die<30"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.SoulShards >= 1 and target.time_to_die < 30
	end,
}

a.spells["unstable_affliction,if=target=sim.target&active_enemies>1&soul_shard>=4"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.ActiveEnemies > 1 and x.SoulShards >= 4
	end,
}

a.spells["unstable_affliction,if=target=sim.target&(buff.active_uas.stack=0|(!prev_gcd.3.unstable_affliction&prev_gcd.1.unstable_affliction))&dot.agony.remains>cast_time+(6.5*spell_haste)"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.SoulShards >= 1 and (buff.active_uas.stack == 0 or (not prev_gcd[3].unstable_affliction and prev_gcd[1].unstable_affliction)) and dot.agony.remains > action.unstable_affliction.cast_time + (6.5 * x.Haste)
	end,
}

a.spells["reap_souls,if=buff.deadwind_harvester.remains<dot.unstable_affliction_1.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_2.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_3.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_4.remains|buff.deadwind_harvester.remains<dot.unstable_affliction_5.remains&buff.active_uas.stack>1"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return buff.tormented_souls.react_nogcd >= 1 and (buff.deadwind_harvester.remains_nogcd < dot.unstable_affliction_1.remains_nogcd or buff.deadwind_harvester.remains_nogcd < dot.unstable_affliction_2.remains_nogcd or buff.deadwind_harvester.remains_nogcd < dot.unstable_affliction_3.remains_nogcd or buff.deadwind_harvester.remains_nogcd < dot.unstable_affliction_4.remains_nogcd or buff.deadwind_harvester.remains_nogcd < dot.unstable_affliction_5.remains_nogcd and buff.active_uas.stack_nogcd > 1)
	end,
}

a.spells["life_tap,if=mana.pct<=10"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return x.ManaPercent <= 10
	end,
}

a.spells["life_tap,if=prev_gcd.1.life_tap&buff.active_uas.stack=0&mana.pct<50"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return prev_gcd[1].life_tap and buff.active_uas.stack == 0 and x.ManaPercent < 50
	end,
}

a.spells["drain_soul,chain=1,interrupt=1"] = {
	ID = 198590--[[Drain Soul]],
	Check = function(z)
		if s.Channeling(198590--[[Drain Soul]], "player") then
			z.FlashBrightness = 30
		else
			z.FlashBrightness = 100
		end			
		return not s.Moving("player")
	end,
}

a.spells["life_tap,moving=1,if=mana.pct<80"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return s.Moving("player") and x.ManaPercent < 80
	end,
}

a.spells["agony,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return s.Moving("player") and dot.agony.remains < dot.agony.duration - (3 * dot.agony.tick_time)
	end,
}

a.spells["siphon_life,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"] = {
	ID = 63106--[[Siphon Life]],
	Check = function(z)
		return s.Moving("player") and dot.siphon_life.remains < dot.siphon_life.duration - (3 * dot.siphon_life.tick_time)
	end,
}

a.spells["corruption,moving=1,cycle_targets=1,if=remains<duration-(3*tick_time)"] = {
	ID = 172--[[Corruption]],
	Check = function(z)
		return s.Moving("player") and dot.corruption.remains < dot.corruption.duration - (3 * dot.corruption.tick_time)
	end,
}

a.spells["life_tap,moving=0"] = {
	ID = 1454--[[Life Tap]],
	Check = function(z)
		return x.InCombat and not s.Moving("player")
	end,
}

--[[
  _   _                   _   
 | | | | __ _ _   _ _ __ | |_ 
 | |_| |/ _` | | | | '_ \| __|
 |  _  | (_| | |_| | | | | |_ 
 |_| |_|\__,_|\__,_|_| |_|\__|
                              ]]
                              
a.spells["reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.tormented_souls.react>=5|target.time_to_die<=buff.tormented_souls.react*(5+1.5*equipped.144364)+(buff.deadwind_harvester.remains*(5+1.5*equipped.144364)%12*(5+1.5*equipped.144364)))"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return not buff.deadwind_harvester.up_nogcd and s.Time() > 5 and (buff.tormented_souls.react_nogcd >= 5 or target.time_to_die <= buff.tormented_souls.react_nogcd * (5 + 1.5 * s.If(equipped[144364], 1, 0)) + (buff.deadwind_harvester.remains_nogcd * (5 + 1.5 * s.If(equipped[144364], 1, 0)) / 12 * (5 + 1.5 * s.If(equipped[144364], 1, 0))))
	end,
}

a.spells["reap_souls,if=debuff.haunt.remains&!buff.deadwind_harvester.remains"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return debuff.haunt.up_nogcd and not buff.deadwind_harvester.up_nogcd
	end,
}

a.spells["reap_souls,if=active_enemies>1&!buff.deadwind_harvester.remains&time>5&soul_shard>0&((talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|spell_targets.seed_of_corruption>=5)"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return x.ActiveEnemies > 1 and not buff.deadwind_harvester.up_nogcd and s.Time() > 5 and x.SoulShards > 0 and ((talent.sow_the_seeds.enabled and x.ActiveEnemies >= 3) or x.ActiveEnemies >= 5)
	end,
}

a.spells["agony,cycle_targets=1,if=remains<=tick_time+gcd"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.remains <= dot.agony.tick_time + x.MaxGCD
	end,
}
,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
,"soul_harvest,if=buff.soul_harvest.remains<=8&buff.active_uas.stack>=1&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)"
,"potion,if=!talent.soul_harvest.enabled&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|buff.active_uas.stack>2)"
,"potion,if=talent.soul_harvest.enabled&buff.soul_harvest.remains&(trinket.proc.any.react|trinket.stack_proc.any.react|target.time_to_die<=70|!cooldown.haunt.remains|buff.active_uas.stack>2)"
,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd"
,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&(spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<5)"

a.spells["reap_souls,if=(buff.deadwind_harvester.remains+buff.tormented_souls.react*(5+equipped.144364))>=(12*(5+1.5*equipped.144364))"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return (buff.deadwind_harvester.remains_nogcd + buff.tormented_souls.react_nogcd * (5 + s.If(equipped[144364], 1, 0))) >= (12 * (5 + 1.5 * s.If(equipped[144364], 1, 0)))
	end,
}
,"haunt"

a.spells["agony,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.refreshable and target.time_to_die >= dot.agony.remains
	end,
}
,"siphon_life,if=remains<=duration*0.3&target.time_to_die>=remains"
,"siphon_life,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"
,"seed_of_corruption,if=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3|spell_targets.seed_of_corruption>=5|spell_targets.seed_of_corruption>=3&dot.corruption.remains<=cast_time+travel_time"
,"corruption,if=remains<=duration*0.3&target.time_to_die>=remains"
,"corruption,cycle_targets=1,if=remains<=duration*0.3&target.time_to_die>=remains&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*6&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*4"

a.spells["unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&((soul_shard>=4&!talent.contagion.enabled)|soul_shard>=5|target.time_to_die<30)"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.ActiveEnemies < 5 and ((x.SoulShards >= 4 and not talent.contagion.enabled) or x.SoulShards >= 5 or target.time_to_die < 30)
	end,
}

a.spells["unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&soul_shard>=4&talent.contagion.enabled&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.ActiveEnemies > 1 and (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.SoulShards >= 4 and talent.contagion.enabled and cooldown.haunt.remains < 15 and dot.unstable_affliction_1.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_2.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_3.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_4.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_5.remains < action.unstable_affliction.cast_time
	end,
}

a.spells["unstable_affliction,cycle_targets=1,if=active_enemies>1&(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&(equipped.132381|equipped.132457)&cooldown.haunt.remains<15&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.ActiveEnemies > 1 and (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and (equipped[132381] or equipped[132457]) and cooldown.haunt.remains < 15 and dot.unstable_affliction_1.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_2.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_3.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_4.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_5.remains < action.unstable_affliction.cast_time
	end,
}

a.spells["unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&talent.contagion.enabled&soul_shard>=4&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.ActiveEnemies < 5 and talent.contagion.enabled and x.SoulShards >= 4 and dot.unstable_affliction_1.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_2.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_3.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_4.remains < action.unstable_affliction.cast_time and dot.unstable_affliction_5.remains < action.unstable_affliction.cast_time
	end,
}

a.spells["unstable_affliction,if=(!talent.sow_the_seeds.enabled|spell_targets.seed_of_corruption<3)&spell_targets.seed_of_corruption<5&debuff.haunt.remains>=action.unstable_affliction_1.tick_time*2"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return (not talent.sow_the_seeds.enabled or x.ActiveEnemies < 3) and x.ActiveEnemies < 5 and debuff.haunt.remains >= 2 / x.Haste * 2
	end,
}

a.spells["reap_souls,if=!buff.deadwind_harvester.remains&(buff.active_uas.stack>1|(prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1))"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return not buff.deadwind_harvester.up_nogcd and (buff.active_uas.stack_nogcd > 1 or (prev_gcd[1].unstable_affliction and buff.tormented_souls.react_nogcd > 1))
	end,
}

a.spells["agony,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.remains <= dot.agony.duration - (3 * dot.agony.tick_time)
	end,
}
,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"

--[[
 __        __    _ _   _          
 \ \      / / __(_) |_| |__   ___ 
  \ \ /\ / / '__| | __| '_ \ / _ \
   \ V  V /| |  | | |_| | | |  __/
    \_/\_/ |_|  |_|\__|_| |_|\___|
                                  ]]


a.spells["reap_souls,if=!buff.deadwind_harvester.remains&time>5&(buff.soul_harvest.remains>=(5+1.5*equipped.144364)&buff.active_uas.stack>1|buff.concordance_of_the_legionfall.react|trinket.proc.intellect.react|trinket.stacking_proc.intellect.react|trinket.proc.mastery.react|trinket.stacking_proc.mastery.react|trinket.proc.crit.react|trinket.stacking_proc.crit.react|trinket.proc.versatility.react|trinket.stacking_proc.versatility.react|trinket.proc.spell_power.react|trinket.stacking_proc.spell_power.react)"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return not buff.deadwind_harvester.up_nogcd and s.Time() > 5 and (buff.soul_harvest.remains_nogcd >= (5 + 1.5 * s.If(equipped[144364], 1, 0)) and buff.active_uas.stack_nogcd > 1 or buff.concordance_of_the_legionfall.up_nogcd)
	end,
}

a.spells["agony,if=remains<=tick_time+gcd"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.remains <= dot.agony.tick_time + x.MaxGCD
	end,
}

a.spells["agony,cycle_targets=1,max_cycle_targets=3,target_if=sim.target!=target&remains<=tick_time+gcd&time_to_die>tick_time*3"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.remains <= dot.agony.tick_time + x.MaxGCD and time_to_die > dot.agony.tick_time * 3
	end,
}

a.spells["unstable_affliction,if=soul_shard=5|(time_to_die<=((duration+cast_time)*soul_shard))"] = {
	ID = 30108--[[Unstable Affliction]],
	Check = function(z)
		return x.SoulShards == 5 or (target.time_to_die <= (((8 - 8 % (2 / x.Haste)) + action.unstable_affliction.cast_time) * x.SoulShards))
	end,
}
,"drain_soul,cycle_targets=1,if=target.time_to_die<=gcd*2&soul_shard<5"
,"soul_harvest,if=sim.target=target&buff.soul_harvest.remains<=8&(raid_event.adds.in>20|active_enemies>1|!raid_event.adds.exists)&(buff.active_uas.stack>=2|active_enemies>3)&(!talent.deaths_embrace.enabled|time_to_die>120|time_to_die<30)"
,"potion,if=(!talent.soul_harvest.enabled|buff.soul_harvest.remains>12)&(trinket.proc.any.react|trinket.stack_proc.any.react|buff.active_uas.stack>=2)"
,"siphon_life,cycle_targets=1,if=remains<=tick_time+gcd&time_to_die>tick_time*2"
,"corruption,cycle_targets=1,if=remains<=tick_time+gcd&((spell_targets.seed_of_corruption<3&talent.sow_the_seeds.enabled)|spell_targets.seed_of_corruption<5)&time_to_die>tick_time*2"
,"life_tap,if=mana.pct<40&(buff.active_uas.stack<1|!buff.deadwind_harvester.remains)"
,"seed_of_corruption,if=(talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption>=3)|(spell_targets.seed_of_corruption>3&dot.corruption.refreshable)"
,"unstable_affliction,if=talent.contagion.enabled&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=talent.absolute_corruption.enabled&set_bonus.tier21_4pc&debuff.tormented_agony.remains<=cast_time"
,"unstable_affliction,cycle_targets=1,target_if=buff.deadwind_harvester.remains>=duration+cast_time&dot.unstable_affliction_1.remains<cast_time&dot.unstable_affliction_2.remains<cast_time&dot.unstable_affliction_3.remains<cast_time&dot.unstable_affliction_4.remains<cast_time&dot.unstable_affliction_5.remains<cast_time"
,"unstable_affliction,if=buff.deadwind_harvester.remains>tick_time*2&(!set_bonus.tier21_4pc|talent.contagion.enabled|soul_shard>1)&(!talent.contagion.enabled|soul_shard>1|buff.soul_harvest.remains)&(dot.unstable_affliction_1.ticking+dot.unstable_affliction_2.ticking+dot.unstable_affliction_3.ticking+dot.unstable_affliction_4.ticking+dot.unstable_affliction_5.ticking<5)"

a.spells["reap_souls,if=!buff.deadwind_harvester.remains&buff.active_uas.stack>1"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return not buff.deadwind_harvester.up_nogcd and buff.active_uas.stack_nogcd > 1
	end,
}

a.spells["reap_souls,if=!buff.deadwind_harvester.remains&prev_gcd.1.unstable_affliction&buff.tormented_souls.react>1"] = {
	ID = 216698--[[Reap Souls]],
	NoGCD = true,
	FlashColor = "Yellow",
	Check = function(z)
		return not buff.deadwind_harvester.up_nogcd and prev_gcd[1].unstable_affliction and buff.tormented_souls.react_nogcd > 1
	end,
}
,"life_tap,if=talent.empowered_life_tap.enabled&buff.empowered_life_tap.remains<duration*0.3&(!buff.deadwind_harvester.remains|buff.active_uas.stack<1)"

a.spells["agony,if=refreshable&time_to_die>=remains"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return dot.agony.refreshable and time_to_die > dot.agony.remains
	end,
}
,"siphon_life,if=refreshable&time_to_die>=remains"
,"corruption,if=refreshable&time_to_die>=remains"

a.spells["agony,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"] = {
	ID = 980--[[Agony]],
	Check = function(z)
		return time_to_die > dot.agony.tick_time * 3 and not buff.deadwind_harvester.remains and dot.agony.refreshable
	end,
}
,"siphon_life,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
,"corruption,cycle_targets=1,target_if=sim.target!=target&time_to_die>tick_time*3&!buff.deadwind_harvester.remains&refreshable"
,"siphon_life,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
,"corruption,moving=1,cycle_targets=1,if=remains<=duration-(3*tick_time)"
