local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

x.Variable = {}

local wildimps = {}

x.Buff.wild_imps = {}
x.Buff.dreadstalkers = {}
x.Buff.grimoire_felguard = {}

a.wild_imp_count = function()
       local i = 0
       local ts = GetTime()
       foreach(wildimps, function(k, v)
               if ts - v.summoned >= 22 then
                       wildimps[k] = nil
               else
                       i = i + 1
               end
       end)
       return i
end

a.COMBAT_LOG_EVENT_UNFILTERED = function ()
	CurrentTimestamp, event, _, sourceGUID, sourceName, sourceFlags, _, destGUID, destName, destFlags, _, spellId, spellName = CombatLogGetCurrentEventInfo()
	local ts = GetTime()
	myself = UnitGUID("player")
	pet = UnitGUID("pet")
	target_is_outsider = bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	source_is_outsider = bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0

	if (event=="SPELL_SUMMON" and destName=="Wild Imp" and sourceGUID == myself) then
		wildimps[destGUID] = {}
		wildimps[destGUID].summoned = ts
		wildimps[destGUID].energy = 100
	end

	-- Imps die after casting 10 times:
	if event == "SPELL_CAST_SUCCESS" and sourceName == "Wild Imp" then
		for key, value in pairs(wildimps) do
			if sourceGUID == key then
				wildimps[key].energy = wildimps[key].energy - 20
				if wildimps[key].energy <= 0 then
					wildimps[key] = nil
				end
			end
		end
	end

	if event == "SPELL_CAST_SUCCESS" and sourceGUID == myself and spellId == 196277--[[Implosion]] then
		wildimps = {}
	end

	if event == "SPELL_CAST_SUCCESS" and sourceGUID == myself and spellId == 264130--[[Power Siphon]] then
		local num = 0
		for key, value in pairs(wildimps) do
			if num < 2 then
				wildimps[key] = nil
				num = num + 1
			end
		end
	end
end
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)
